com.holonplatform.core.query

## Interface PropertyConstantExpression<T,E>

- Type Parameters:
    `T` - Expression type
    `E` - Concrete value type
  All Superinterfaces:
    ConstantExpression<T,E>, Expression, QueryExpression<E>

      public interface PropertyConstantExpression<T,E>
      extends ConstantExpression<T,E>

  A `QueryExpression` which represents a `Property` value.
  Since:
    5.0.0

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface com.holonplatform.core.Expression

      `Expression.ExpressionResolverFunction<E extends Expression,R extends Expression>, Expression.InvalidExpressionException`

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `static <T> PropertyConstantExpression<Collection<T>,T>` | `create(Property<T> property, Collection<? extends T> values)` Create a `PropertyConstantExpression` which represents a collection of constant values bound to a `Property`.
    `static <T> PropertyConstantExpression<Collection<T>,T>` | `create(Property<T> property, T... values)` Create a `PropertyConstantExpression` which represents a collection of constant values bound to a `Property`.
    `static <T> PropertyConstantExpression<T,T>` | `create(Property<T> property, T value)` Create a `PropertyConstantExpression` which represents a constant value bound to a `Property`.
    `default Class<?>` | `getModelType()` Get the model type.
    `Object` | `getModelValue()` Get the model value.
    `Property<E>` | `getProperty()` Get the property to which the value is bound.

    - ### Methods inherited from interface com.holonplatform.core.query.ConstantExpression

      `create, create, create, getValue`

    - ### Methods inherited from interface com.holonplatform.core.query.QueryExpression

      `getType`

    - ### Methods inherited from interface com.holonplatform.core.Expression

      `validate`

- - ### Method Detail

    - #### getProperty

          Property<E> getProperty()

      Get the property to which the value is bound.
      Returns:
        the property

    - #### getModelValue

          Object getModelValue()

      Get the model value.
      Returns:
        The constant expression value, converted to model type if a `PropertyValueConverter` is available.

    - #### getModelType

          default Class<?> getModelType()

      Get the model type.
      Returns:
        The constant expresion type, using the model type if a `PropertyValueConverter` is available.

    - #### create

          static <T> PropertyConstantExpression<T,T> create(Property<T> property,
                                                            T value)

      Create a `PropertyConstantExpression` which represents a constant value bound to a `Property`.
      Type Parameters:
        `T` - Expression type
      Parameters:
        `property` - Property to which the value is bound (not null)
        `value` - Constant value (not null)
      Returns:
        A new constant expression

    - #### create

          static <T> PropertyConstantExpression<Collection<T>,T> create(Property<T> property,
                                                                        Collection<? extends T> values)

      Create a `PropertyConstantExpression` which represents a collection of constant values bound to a `Property`.
      Type Parameters:
        `T` - Expression type
      Parameters:
        `property` - Property to which the value is bound (not null)
        `values` - Expression values (not null)
      Returns:
        A new collection expression

    - #### create

          @SafeVarargs
          static <T> PropertyConstantExpression<Collection<T>,T> create(Property<T> property,
                                                                                      T... values)

      Create a `PropertyConstantExpression` which represents a collection of constant values bound to a `Property`.
      Type Parameters:
        `T` - Expression type
      Parameters:
        `property` - Property to which the value is bound (not null)
        `values` - Expression values (not null)
      Returns:
        A new collection expression

Copyright © 2017 The Holon Platform. All rights reserved.